import type { Extension } from "@codemirror/state";
import { RecorderPlugin, ReplayDataRecorder } from "@liqvid/recording";
import { ReplayData } from "@liqvid/utils/replay-data";
import { scrollCmd } from ".";
export declare type EditorChange = [[number, ...(EditorChange | number | string)[]], [number, number]];
export declare type SpecialKey = string;
export declare type ScrollAction = [typeof scrollCmd, number, number] | [typeof scrollCmd, number];
export declare type CaptureData = EditorChange | ScrollAction | SpecialKey;
export declare class CodeRecorder extends ReplayDataRecorder<CaptureData> {
    constructor();
    /**
     * Get a CodeMirror extension for recording.
     * @param specialKeys Map of key sequences to commands, e.g. {"Mod-Enter": "run"}.
     * @returns CodeMirror extension.
     */
    extension(specialKeys?: Record<string, string> | string[]): Extension;
}
export declare const CodeRecording: RecorderPlugin<[
    number,
    CaptureData
], ReplayData<CaptureData>, CodeRecorder>;
